const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const technologies = sequelize.define(
    'technologies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name_ar: {
        type: DataTypes.TEXT,
      
      

      },

technology_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"cnc",


"waterjet",


"laser_measurement",


"cad_cam",


"polishing_line",


"other"

        ],

      },

description_ar: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  technologies.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.technologies.hasMany(db.service_technologies, {
      as: 'service_technologies_technology',
      foreignKey: {
          name: 'technologyId',
      },
      constraints: false,
    });













//end loop





    db.technologies.hasMany(db.file, {
      as: 'images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.technologies.getTableName(),
        belongsToColumn: 'images',
      },
    });


    db.technologies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.technologies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return technologies;
};


